--Let flexbar2 know we've got sexy business ready for it
local DreamLayout = FlexBar2:NewModule("DreamLayout"); 

-- Create a ButtonMixin, this will be mixed into every button object 
DreamLayout.ButtonMixin = {}; 

--Define BackdropTable here so as to avoid a longer check during Activate()
local BackdropTable = {bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 1, edgeFile = "", edgeSize = 0, insets = {left = 0, right = 0, top = 0, bottom = 0},};

-- Code influenced by Bartender3, from nevcairiel. Ensured backdrop strata for transparencies
function DreamLayout.ButtonMixin:Activate() 
	self.Frame.Icon:SetTexCoord(.08, 0.92, 0.08, 0.92); 
	self.Frame.Icon:SetPoint("TOPLEFT", self.Frame, "TOPLEFT", 4, -4); 
	self.Frame.Icon:SetPoint("BOTTOMRIGHT", self.Frame, "BOTTOMRIGHT", -4, 4); 
	if(not self.Frame.DreamLayoutFrame) then 
		local DreamLayoutFrame = CreateFrame("Frame", nil, self.Frame); 
		self.Frame.DreamLayoutFrame = DreamLayoutFrame;
		DreamLayoutFrame:SetFrameStrata("LOW");
		DreamLayoutFrame:ClearAllPoints(); 
		DreamLayoutFrame:SetBackdrop(BackdropTable);
		DreamLayoutFrame:SetBackdropColor(0, 0, 0, 0.6); 
		DreamLayoutFrame:SetAllPoints(self.Frame); 
		DreamLayoutFrame:SetPoint("TOPLEFT", self.Frame, "TOPLEFT", -0.5, 0.5);
		DreamLayoutFrame:SetPoint("BOTTOMRIGHT", self.Frame, "BOTTOMRIGHT", 0.5, -0.5);
	end 
	self.Frame.DreamLayoutFrame:Show(); 
	self.Frame:SetNormalTexture(""); 
end 

-- Thanks cncfanatics for helping to clear up parenting for me <3
function DreamLayout.ButtonMixin:Deactivate() 
	self.Frame.Icon:SetTexCoord(0, 1, 0, 1); 
	self.Frame.DreamLayoutFrame:Hide(); 
	self.Frame:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2"); 
	self.Frame.Icon:ClearAllPoints();
	self.Frame.Icon:SetAllPoints(self.Frame);
end
